﻿Module Horizon

    'Horizonで利用する配列
    Dim A(,) As Double, B() As Double
    Dim f(,) As Double
    Dim C(3, 3) As Double

    Dim IFLG As Integer


    Dim i_checker As Integer

    Private Sub Bcholeski(ByVal Nband As Long, ByVal m As Long)

        Const Small As Double = 0.000000001
        Dim Nb1 As Long
        Dim Mnb As Long
        Dim Ks As Long, Kt As Long, Kks As Long
        Dim Im1 As Long, Ip1 As Long, Jp1 As Long
        Dim Sa As Double, Sb As Double
        Dim i As Long, j As Long, k As Long

        'Chleski method (see Togawa(1971,1985))
        IFLG = 2
        Nb1 = Nband + 1
        Mnb = m - Nband
        '                              decomposition  A = P'P
        If A(1, 1) < Small Then GoTo 6800
        A(1, 1) = Math.Sqrt(A(1, 1))

        For j = 2 To Nb1
            A(1, j) = A(1, j) / A(1, 1)
        Next j

        B(1) = B(1) / A(1, 1)

        For i = 2 To m
            If i < Nb1 Then
                Ks = 1
            Else
                Ks = i - Nband
            End If
            If i > Mnb Then
                Kt = m
            Else
                Kt = i + Nband
            End If

            Im1 = i - 1
            Ip1 = i + 1
            Sa = A(i, 1)
            Sb = B(i)

            For k = Ks To Im1
                Sa = Sa - A(k, Ip1 - k) ^ 2
                Sb = Sb - A(k, Ip1 - k) * B(k)
            Next k
            '
            If Sa <= Small Then GoTo 6800
            A(i, 1) = Math.Sqrt(Sa)
            B(i) = Sb / A(i, 1)
            If i = m Then GoTo 6690

            For j = Ip1 To Kt
                Sa = A(i, j - Im1)
                Jp1 = j + 1
                If j < Nb1 Then
                    Kks = 1
                Else
                    Kks = j - Nband
                End If

                If Kks > Im1 Then GoTo 6650

                For k = Kks To Im1
                    Sa = Sa - A(k, Ip1 - k) * A(k, Jp1 - k)
                Next k
6650:           A(i, j - Im1) = Sa / A(i, 1)

            Next j
        Next i
        '                              solution --> B(I)
6690:   B(m) = B(m) / A(m, 1)

        For i = m - 1 To 1 Step -1
            If (i > Mnb) Then
                Kt = m
            Else
                Kt = i + Nband
            End If
            Ip1 = i + 1
            Im1 = i - 1
            Sb = B(i)

            For k = Ip1 To Kt
                Sb = Sb - A(i, k - Im1) * B(k)
            Next k

            B(i) = Sb / A(i, 1)

        Next i
        IFLG = 0

6800:

    End Sub

    Private Sub Dmat(ByVal Nx As Long, ByVal Ny As Long, _
    ByVal Xmin As Double, ByVal Ymin As Double, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Xd() As Double, ByVal Yd() As Double, ByVal Dfdx() As Double, ByVal Dfdy() As Double, _
    ByVal Nd As Long, ByRef Nddt As Long, ByVal BetaH As Double)

        Static k As Long
        'Dim Xlmin As Double, Ylmin As Double
        'Dim XlMax As Double, YlMax As Double
        Dim Cx As Double, Cy As Double
        Dim idd As Long, jdd As Long
        Dim iss As Integer, jss As Integer
        Dim wt As Double
        Dim v As Double

        '      dimension Xd(mxdt), Yd(mxdt), dfdx(mxdt), dfdy(mxdt)
        '      dimension C(3, 3)

        Nddt = 0
        For k = 1 To Nd
            Gridij(Xd(k), Yd(k), idd, jdd, Cx, Cy, iss, jss, Nx, Ny, Xmin, Ymin, Dx, Dy)
            If IFLG = 0 Then Nddt = Nddt + 1
        Next
        If Nddt = 0 Then Exit Sub

        wt = BetaH / Nddt
        For k = 1 To Nd
            Gridij(Xd(k), Yd(k), idd, jdd, Cx, Cy, iss, jss, Nx, Ny, Xmin, Ymin, Dx, Dy)
            If IFLG <> 0 Then GoTo 200

            'c      matrix for squred residual of (df/dx)

            Cdfdx9(Cx, Cy, iss, jss, Dx)
            v = Dfdx(k)
            Block9(idd, jdd, Nx, Ny, wt, v)

            'c      matrix for squared residual of(df/dy)

            Cdfdy9(Cx, Cy, iss, jss, Dy)
            v = Dfdy(k)
            Block9(idd, jdd, Nx, Ny, wt, v)
200:    Next

    End Sub

    Private Sub Hmat(ByRef f(,) As Double, ByVal Nx As Long, ByVal Ny As Long, _
    ByVal Xmin As Double, ByVal Ymin As Double, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Xh() As Double, ByVal Yh() As Double, ByVal Zh() As Double, ByVal Lm() As Integer, _
    ByVal Nh As Long, ByRef Nhdt As Long, ByVal AlphaH As Double)

        Static k As Long
        Dim ih As Long, jh As Long
        Dim Cx As Double, Cy As Double
        Dim iss As Integer, jss As Integer
        Dim wt As Double
        Dim Dev As Double
        Dim Zc As Double
        Dim v As Double

        Nhdt = 0
        For k = 1 To Nh
            Gridij(Xh(k), Yh(k), ih, jh, Cx, Cy, iss, jss, Nx, Ny, Xmin, Ymin, Dx, Dy)
            If IFLG = 0 Then Nhdt = Nhdt + 1
        Next

        If Nhdt = 0 Then Exit Sub

        wt = AlphaH / Nhdt

        i_checker = 1

        For k = 1 To Nh
            Gridij(Xh(k), Yh(k), ih, jh, Cx, Cy, iss, jss, Nx, Ny, Xmin, Ymin, Dx, Dy)
            If IFLG <> 0 Then GoTo 200
            Cfval9(f, ih, jh, Cx, Cy, iss, jss, Zc)
            Dev = Zc - Zh(k)
            If Lm(k) <> 0 And Dev * Lm(k) > 0 Then GoTo 200
            v = Zh(k)
            Block9(ih, jh, Nx, Ny, wt, v)
200:    Next

    End Sub

    Private Sub Cnull()

        Dim i As Integer, j As Integer

        For i = 1 To 3
            For j = 1 To 3
                C(i, j) = 0
            Next
        Next

    End Sub

    Private Sub Cdfdx9(ByVal Cx As Double, ByVal Cy As Double, ByVal iss As Integer, ByVal jss As Integer, ByVal Dx As Double)

        Cnull()
        C(1, 2) = (-0.5 + Cx) / Dx
        C(2, 2) = -2 * Cx / Dx
        C(3, 2) = (0.5 + Cx) / Dx
        C(2 + iss, 2 + jss) = C(2 + iss, 2 + jss) + Cy / Dx
        C(2 + iss, 3 + jss) = C(2 + iss, 3 + jss) - Cy / Dx
        C(3 + iss, 2 + jss) = C(3 + iss, 2 + jss) - Cy / Dx
        C(3 + iss, 3 + jss) = C(3 + iss, 3 + jss) + Cy / Dx

    End Sub

    Private Sub Cdfdy9(ByVal Cx As Double, ByVal Cy As Double, ByVal iss As Integer, ByVal jss As Integer, ByVal Dy As Double)

        Cnull()
        C(2, 1) = (-0.5 + Cy) / Dy
        C(2, 2) = -2 * Cy / Dy
        C(2, 3) = (0.5 + Cy) / Dy
        C(2 + iss, 2 + jss) = C(2 + iss, 2 + jss) + Cx / Dy
        C(2 + iss, 3 + jss) = C(2 + iss, 3 + jss) - Cx / Dy
        C(3 + iss, 2 + jss) = C(3 + iss, 2 + jss) - Cx / Dy
        C(3 + iss, 3 + jss) = C(3 + iss, 3 + jss) + Cx / Dy

    End Sub

    Private Sub Cfval9(ByRef f(,) As Double, ByVal i As Long, ByVal j As Long, ByVal Cx As Double, ByVal Cy As Double, _
    ByVal iss As Integer, ByVal jss As Integer, ByRef Zc As Double)

        Dim ip As Integer, jp As Integer

        Cnull()
        C(1, 2) = (-Cx + Cx * Cx) / 2
        C(2, 1) = (-Cy + Cy * Cy) / 2
        C(2, 2) = 1 - Cx * Cx - Cy * Cy
        C(2, 3) = (Cy + Cy * Cy) / 2
        C(3, 2) = (Cx + Cx * Cx) / 2
        C(2 + iss, 2 + jss) = C(2 + iss, 2 + jss) + Cx * Cy
        C(2 + iss, 3 + jss) = C(2 + iss, 3 + jss) - Cx * Cy
        C(3 + iss, 2 + jss) = C(3 + iss, 2 + jss) - Cx * Cy
        C(3 + iss, 3 + jss) = C(3 + iss, 3 + jss) + Cx * Cy

        '        value zc = f(xh(k),yh(k))
        Zc = 0
        For ip = 1 To 3
            For jp = 1 To 3
                Zc = Zc + C(ip, jp) * f(i + ip - 2, j + jp - 2)
            Next
        Next

    End Sub

    Private Sub Gridij(ByVal X As Double, ByVal Y As Double, ByRef i As Long, ByRef j As Long, _
    ByRef Cx As Double, ByRef Cy As Double, ByRef iss As Integer, ByRef jss As Integer, _
    ByVal Nx As Long, ByVal Ny As Long, ByVal Xmin As Double, ByVal Ymin As Double, _
    ByVal Dx As Double, ByVal Dy As Double)

        'c----------------------subroutine gridij------------------------------
        'c      find the grid (i,j) nearest to a given point (x,y)
        'c
        'c  iss=0 jss=0      iss=0 jss=-1      iss=-1 jss=-1    iss=-1 jss=0
        'c       +----+      +----+                 +                +
        'c       l    l      l    l                 l                l
        'c       l *  l      l  * l                 l                l
        'c  +----+----+      +----+----+       +----+----+      +----+----+
        'c       l                l            l  * l                l *  l
        'c       l                l            l    l                l    l
        'c       +                +            +----+                +----+
        'c---------------------------------------------------------------------
        '      subroutine gridij(x,y,i,j,cx,cy,iss,jss,nx,ny,xmin,ymin,dx,dy,iflg)

        IFLG = -1
        i = Int((X - Xmin) / Dx + 1.50000001)
        If (i - 1) * (i - Nx) >= 0 Then Exit Sub
        Cx = (X - (Xmin + (i - 1) * Dx)) / Dx
        iss = 0
        If Cx < 0 Then iss = -1

        j = Int((Y - Ymin) / Dy + 1.50000001)
        If (j - 1) * (j - Ny) >= 0 Then Exit Sub
        Cy = (Y - (Ymin + (j - 1) * Dy)) / Dy
        jss = 0
        If Cy < 0 Then jss = -1

        IFLG = 0

        'If i_checker = 1 Then
        '    Debug.WriteLine("i=" & i)
        '    Debug.WriteLine("j=" & j)
        '    Stop
        'End If

    End Sub

    Private Sub Jx(ByVal Nx As Long, ByVal Ny As Long, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Pm1 As Double)

        Dim Wmxy As Double, Wy As Double, wt As Double
        Static i As Long, j As Long
        Dim v As Double

        Cnull()
        C(2, 2) = -1 / Dx
        C(3, 2) = 1 / Dx
        Wmxy = Pm1 / ((Nx - 1) * (Ny - 1))
        v = 0
        For j = 1 To Ny
            Wy = 1
            If j = 1 Or j = Ny Then Wy = 0.5
            wt = Wmxy * Wy
            For i = 1 To Nx - 1
                Block9(i, j, Nx, Ny, wt, v)
            Next
        Next

    End Sub

    Private Sub Jxx(ByVal Nx As Long, ByVal Ny As Long, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Pm2 As Double)

        Dim Wmxy As Double, Wx As Double, Wy As Double, wt As Double
        Static i As Long, j As Long
        Dim v As Double

        Cnull()
        C(1, 2) = 1 / Dx ^ 2
        C(2, 2) = -2 / Dx ^ 2
        C(3, 2) = 1 / Dx ^ 2
        Wmxy = Pm2 * Dx * Dy
        v = 0
        For j = 1 To Ny
            Wy = 1
            If j = 1 Or j = Ny Then Wy = 0.5
            For i = 2 To Nx - 1
                Wx = 1
                If i = 2 Or i = Nx - 1 Then Wx = 1.5
                wt = Wmxy * Wx * Wy
                Block9(i, j, Nx, Ny, wt, v)
            Next
        Next

    End Sub

    Private Sub Jxy(ByVal Nx As Long, ByVal Ny As Long, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Pm2 As Double)

        Static i As Long, j As Long
        Dim wt As Double, v As Double

        Cnull()
        C(2, 2) = 1 / (Dx * Dy)
        C(2, 3) = -1 / (Dx * Dy)
        C(3, 2) = -1 / (Dx * Dy)
        C(3, 3) = 1 / (Dx * Dy)
        wt = 2 * Pm2 * Dx * Dy
        v = 0
        For i = 1 To Nx - 1
            For j = 1 To Ny - 1
                Block9(i, j, Nx, Ny, wt, v)
            Next
        Next

    End Sub

    Private Sub Jy(ByVal Nx As Long, ByVal Ny As Long, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Pm1 As Double)

        Dim Wmxy As Double, Wx As Double, wt As Double
        Static i As Long, j As Long
        Dim v As Double

        Cnull()
        C(2, 2) = -1 / Dy
        C(2, 3) = 1 / Dy
        Wmxy = pm1 / ((Nx - 1) * (Ny - 1))
        v = 0
        For i = 1 To Nx
            Wx = 1
            If i = 1 Or i = Nx Then Wx = 0.5
            wt = Wmxy * Wx
            For j = 1 To Ny - 1
                Block9(i, j, Nx, Ny, wt, v)
            Next
        Next

    End Sub

    Private Sub Jyy(ByVal Nx As Long, ByVal Ny As Long, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Pm2 As Double)

        Dim Wmxy As Double, Wx As Double, Wy As Double, wt As Double
        Static i As Long, j As Long
        Dim v As Double

        Cnull()
        C(2, 1) = 1 / Dy ^ 2
        C(2, 2) = -2 / Dy ^ 2
        C(2, 3) = 1 / Dy ^ 2
        Wmxy = Pm2 * Dx * Dy
        v = 0
        For i = 1 To Nx
            Wx = 1
            If i = 1 Or i = Nx Then Wx = 0.5
            For j = 2 To Ny - 1
                Wy = 1
                If j = 2 Or j = Ny - 1 Then Wy = 1.5
                wt = Wmxy * Wx * Wy
                Block9(i, j, Nx, Ny, wt, v)
            Next
        Next

    End Sub

    Private Sub Block9(ByVal i As Long, ByVal j As Long, ByVal Nx As Long, ByVal Ny As Long, _
    ByVal wt As Double, ByVal v As Double)

        Dim ip As Integer, jp As Integer
        Dim iq As Integer, jq As Integer
        Dim k1 As Long, k2 As Long

        For ip = 1 To 3
            For jp = 1 To 3
                k1 = Ny * (i + ip - 3) + (j + jp - 2)
                If (i + ip - 3) * (i + ip - Nx - 2) > 0 Then GoTo 100
                If (j + jp - 3) * (j + jp - Ny - 2) > 0 Then GoTo 100
                B(k1) = B(k1) + wt * C(ip, jp) * v
                For iq = 1 To 3
                    For jq = 1 To 3
                        k2 = Ny * (iq - ip) + (jq - jp + 1)
                        If k2 >= 1 Then A(k1, k2) = A(k1, k2) + wt * C(ip, jp) * C(iq, jq)
                    Next jq
                Next iq
100:        Next jp
        Next ip

    End Sub

    Private Sub Jvalue(ByRef f(,) As Double, ByVal Nx As Long, ByVal Ny As Long, _
    ByVal Dx As Double, ByVal Dy As Double, ByRef Qj1 As Double, ByRef Qj2 As Double)

        'c----------------------subroutine Jvalue------------------------------
        'c      Evaluation of J1 and J2 for final solution
        'c---------------------------------------------------------------------
        '      subroutine Jvalue(f,ngrid,nx,ny,dx,dy,Qj1,Qj2)
        '      dimension f(ngrid, ngrid)
        'c Jx

        Dim i As Long, j As Long
        Dim Qjx As Double, Qjy As Double
        Dim Qjxx As Double, Qjyy As Double, Qjxy As Double
        Dim Wx As Double, Wy As Double

        ' Jx
        Qjx = 0
        For j = 1 To Ny
            Wy = 1
            If j = 1 Or j = Ny Then Wy = 0.5
            For i = 1 To Nx - 1
                Qjx = Qjx + Wy * (f(i + 1, j) - f(i, j)) ^ 2
            Next
        Next

        ' Jy
        Qjy = 0
        For i = 1 To Nx
            Wx = 1
            If i = 1 Or i = Nx Then Wx = 0.5
            For j = 1 To Ny - 1
                Qjy = Qjy + Wx * (f(i, j + 1) - f(i, j)) ^ 2
            Next
        Next
        Qj1 = (Qjx / Dx ^ 2 + Qjy / Dy ^ 2) / ((Nx - 1) * (Ny - 1))

        ' Jxx
        Qjxx = 0
        For j = 1 To Ny
            Wy = 1
            If j = 1 Or j = Ny Then Wy = 0.5
            For i = 2 To Nx - 1
                Wx = 1
                If i = 2 Or i = Nx - 1 Then Wx = 1.5
                Qjxx = Qjxx + Wx * Wy * (f(i + 1, j) - 2 * f(i, j) + f(i - 1, j)) ^ 2
            Next
        Next

        ' Jyy
        Qjyy = 0
        For i = 1 To Nx
            Wx = 1
            If i = 1 Or i = Nx Then Wx = 0.5
            For j = 2 To Ny - 1
                Wy = 1
                If j = 2 Or j = Ny - 1 Then Wy = 1.5
                Qjyy = Qjyy + Wx * Wy * (f(i, j + 1) - 2 * f(i, j) + f(i, j - 1)) ^ 2
            Next
        Next

        ' Jxy
        Qjxy = 0
        For i = 1 To Nx - 1
            For j = 1 To Ny - 1
                Qjxy = Qjxy + (f(i + 1, j + 1) - f(i + 1, j) - f(i, j + 1) + f(i, j)) ^ 2
            Next
        Next
        Qj2 = (Qjxx / Dx ^ 4 + Qjyy / Dy ^ 4 + 2 * Qjxy / (Dx * Dy) ^ 2) * Dx * Dy

    End Sub

    Private Sub Rhvalue(ByRef f(,) As Double, ByVal Nx As Long, ByVal Ny As Long, _
    ByVal Dx As Double, ByVal Dy As Double, ByVal Xmin As Double, ByVal Ymin As Double, _
    ByVal Xh() As Double, ByVal Yh() As Double, ByVal Zh() As Double, ByVal Lm() As Integer, _
    ByVal Nh As Long, ByRef Nhdt As Long, ByRef Qhres As Double)

        'c----------------------subroutine Rhvalue----------------------------
        'c      Evaluation of Rh (residuals) for final solution
        'c--------------------------------------------------------------------
        '      subroutine Rhvalue(f,ngrid,nx,ny,dx,dy,xmin,ymin,
        '     &                   xh,yh,zh,lm,mxdt,nh,nhdt,Qhres)

        Static k As Long
        Dim ih As Long, jh As Long
        Dim Cx As Double, Cy As Double
        Dim iss As Integer, jss As Integer
        Dim Zc As Double
        Dim Dev As Double

        Nhdt = 0
        Qhres = 0
        For k = 1 To Nh
            Gridij(Xh(k), Yh(k), ih, jh, Cx, Cy, iss, jss, Nx, Ny, Xmin, Ymin, Dx, Dy)
            If IFLG <> 0 Then GoTo 100

            Cfval9(f, ih, jh, Cx, Cy, iss, jss, Zc)
            Dev = Zc - Zh(k)
            If Lm(k) <> 0 And Dev * Lm(k) > 0 Then GoTo 100
            Qhres = Qhres + Dev ^ 2
            Nhdt = Nhdt + 1
100:    Next

    End Sub

    Private Sub Rdvalue(ByRef f(,) As Double, ByVal Nx As Long, ByVal Ny As Long, _
    ByVal Dx As Double, ByVal Dy As Double, ByVal Xmin As Double, ByVal Ymin As Double, _
    ByVal Xd() As Double, ByVal Yd() As Double, ByVal Dfdx() As Double, ByVal Dfdy() As Double, _
    ByVal Nd As Long, ByRef Nddt As Long, ByRef Qdres As Double)

        'c----------------------subroutine Rdvalue----------------------------
        'c      Evaluation of Rd (residuals) for final solution
        'c--------------------------------------------------------------------
        '      subroutine Rdvalue(f,ngrid,nx,ny,dx,dy,xmin,ymin,
        '     &                       xd,yd,dfdx,dfdy,mxdt,nd,nddt,Qdres)
        '      dimension f(ngrid, ngrid)
        '      dimension Xd(mxdt), Yd(mxdt)

        Dim i As Integer, j As Integer
        Dim Dev As Double
        Static k As Long

        Dim idd As Long, jdd As Long
        Dim Cx As Double, Cy As Double
        Dim iss As Integer, jss As Integer

        Nddt = 0
        Qdres = 0
        For k = 1 To Nd
            Gridij(Xd(k), Yd(k), idd, jdd, Cx, Cy, iss, jss, Nx, Ny, Xmin, Ymin, Dx, Dy)
            If IFLG <> 0 Then GoTo 100
            'c     residual for (df/dx)
            Cdfdx9(Cx, Cy, iss, jss, Dx)
            Dev = -Dfdx(k)
            For i = 1 To 3
                For j = 1 To 3
                    Dev = Dev + C(i, j) * f(idd + i - 2, jdd + j - 2)
                Next
            Next
            Qdres = Qdres + Dev ^ 2
            'c     residual for (df/dy)
            Cdfdy9(Cx, Cy, iss, jss, Dy)
            Dev = -Dfdy(k)
            For i = 1 To 3
                For j = 1 To 3
                    Dev = Dev + C(i, j) * f(idd + i - 2, jdd + j - 2)
                Next
            Next
            Qdres = Qdres + Dev ^ 2
            Nddt = Nddt + 1
100:    Next

    End Sub

    Sub Optimals(ByRef f(,) As Double, ByVal Nx As Long, ByVal Ny As Long, _
    ByVal Xmin As Double, ByVal Ymin As Double, ByVal Dx As Double, ByVal Dy As Double, _
    ByVal Xh() As Double, ByVal Yh() As Double, ByVal Zh() As Double, ByVal Lm() As Integer, ByVal Nh As Long, _
    ByVal Xd() As Double, ByVal Yd() As Double, ByVal Dfdx() As Double, ByVal Dfdy() As Double, ByVal Nd As Long, _
    ByVal Pm1 As Double, ByVal Pm2 As Double, ByVal GammaH As Double, _
    ByVal AlphaMin As Double, ByVal AlphaMax As Double, _
    ByVal Nitr As Double)


        Dim HorizonCheck As New HorizonCheck

        '中心的ルーチン（入力、処理へ、出力）

        Dim Rn As Double, Mm As Long
        Dim Nmat As Long, Nband As Long
        Dim AlphaH, BetaH As Double
        Dim Ratio As Double
        Dim Nhdt As Long, Nddt As Long
        Dim Qj1 As Double, Qj2 As Double
        Dim Qj As Double, Res As Double
        Dim Qhrn As Double, Qhres As Double, Qhav As Double
        Dim Qdrn As Double, Qdres As Double, Qdav As Double

        Dim Igmt As Long
        Dim k As Long

        Static i, j As Long, Itr As Long

        Dim itry As Integer

        Dim Max_xy As Long

        Max_xy = Nx
        If Max_xy < Ny Then Max_xy = Ny

        ReDim A(Max_xy * Max_xy, 2 * Max_xy + 3), B(Max_xy * Max_xy)

        Nmat = Nx * Ny
        Nband = 2 * Ny + 2
        Mm = Nmat
        IFLG = 3

        '      IFLG = -1
        '                                           (1) parameters m1, m2
        '' '' ''Pm1 = Val(txtM1.Text)
        '' '' ''Pm2 = Val(txtM2.Text)
        '                                           (2) penalty : alpha for elevation data

        itry = 0                                     ' 不等式データがあるかどうか
        For k = 1 To Nh
            itry = itry + Lm(k) ^ 2
        Next

        If itry = 0 Then
            '                                           繰り返しなし(no iteration)
            '                                           等式データのみ
            '' '' ''AlphaMin = Val(txtAlphaMin.Text)
            AlphaMax = AlphaMin
            Ratio = 1
            Nitr = 1
        Else
            '                                           繰り返しあり(iteration)
            '                                           不等式データがある場合
            '' '' ''AlphaMin = Val(txtAlphaMin.Text)
            '' '' ''AlphaMax = Val(txtAlphaMax.Text)
            '' '' ''Nitr = Val(txtNitr.Text)
            Rn = 1 / (Nitr - 1)
            Ratio = (AlphaMax / AlphaMin) ^ Rn
        End If
        '                                           (3) penalty : BetaH for slope data
        '                                               傾斜データがあればGammaHはTextBoxから入れたものを使う
        '' '' ''GammaH = Val(txtRatio.Text)
        If Nd = 0 Then
            GammaH = 0
        End If


        '                                           (4) iterative calculation

        For Itr = 1 To Nitr
            AlphaH = AlphaMin * (Ratio ^ (Itr - 1))
            BetaH = AlphaH * GammaH
            '                       (a) set matrix
            SetMat(Nmat, Nband, f, Nx, Ny, Xmin, Ymin, Dx, Dy, Pm1, Pm2, AlphaH, BetaH, Xh, Yh, Zh, Lm, Nh, Nhdt, Xd, Yd, Dfdx, Dfdy, Nd, Nddt)

            If IFLG = 1 Then Exit Sub

            '                        (b) solve matrix A u = b
            Bcholeski(Nband, Mm)

            If IFLG = 2 Then Exit Sub

            '                        (c) solution f(I,J)
            For i = 1 To Nx
                For j = 1 To Ny
                    Igmt = Ny * (i - 1) + j
                    f(i, j) = B(Igmt)
                Next
            Next

            Jvalue(f, Nx, Ny, Dx, Dy, Qj1, Qj2)

            Rhvalue(f, Nx, Ny, Dx, Dy, Xmin, Ymin, Xh, Yh, Zh, Lm, Nh, Nhdt, Qhres)
            Qhrn = Qhres / Nhdt
            Qhav = Math.Sqrt(Qhrn)

            Qdrn = 0
            If Nd <> 0 Then
                Rdvalue(f, Nx, Ny, Dx, Dy, Xmin, Ymin, Xd, Yd, Dfdx, Dfdy, Nd, Nddt, Qdres)
                If Nddt <> 0 Then
                    Qdrn = Qdres / Nddt
                    Qdav = Math.Sqrt(Qdrn)
                End If
            End If

            Qj = Pm1 * Qj1 + Pm2 * Qj2
            Res = AlphaH * Qhrn + BetaH * Qdrn

        Next Itr

        '推定後、Horizonの計算結果を確認する
        If frmMain.chkHorizonValue.Checked = True Then
            HorizonCheck.Show()
            With HorizonCheck
                .lblQj1.Text = Qj1
                .lblQj2.Text = Qj2
                .lblNhdt.Text = Nhdt
                .lblQhrn.Text = Qhrn
                .lblQhav.Text = Qhav
                .lblNddt.Text = Nddt
                .lblQdrn.Text = Qdrn
                .lblQdav.Text = Qdav
                .lblQjRes.Text = Qj + Res
                .lblQj.Text = Qj
                .lblRes.Text = Res
            End With
        End If

        IFLG = 0
        Erase A, B

    End Sub

    Private Sub SetMat(ByVal Nmat As Long, ByVal Nband As Long, ByRef f(,) As Double, _
    ByVal Nx As Long, ByVal Ny As Long, ByVal Xmin As Double, ByVal Ymin As Double, _
    ByVal Dx As Double, ByVal Dy As Double, ByVal Pm1 As Double, ByVal Pm2 As Double, _
    ByVal AlphaH As Double, ByRef BetaH As Double, _
    ByVal Xh() As Double, ByVal Yh() As Double, ByVal Zh() As Double, ByVal Lm() As Integer, _
    ByVal Nh As Long, ByRef Nhdt As Long, ByVal Xd() As Double, ByVal Yd() As Double, _
    ByVal Dfdx() As Double, ByVal Dfdy() As Double, ByVal Nd As Long, ByRef Nddt As Long)

        'c----------------------subroutine setmat------------------------------
        'c            constracts linear simultaneous equations  A u = b
        'c                 A : band matrix     A(i,j) = (i, (i-1)*ny+j) element
        'c                 b : constant vector (nx*ny elements)
        'c---------------------------------------------------------------------
        '       subroutine setmat(A,b,mxdim,mxgrd,nmat,nband,f,ngrid,
        '     &     nx,ny,xmin,ymin,dx,dy,pm1,pm2,alpha,beta,
        '     &     xh,yh,zh,lm,mxdt,nh,nhdt,xd,yd,dfdx,dfdy,nd,nddt,iflg)

        Dim i As Long, j As Long

        '                                   initialize  A(i,j) & b(i)
        IFLG = 1
        For i = 1 To Nmat
            B(i) = 0
            For j = 1 To Nband + 1
                A(i, j) = 0
            Next
        Next

        '         pm1*J1 = pm1 * double integral of (fx)**2+(fy)**2
        If Pm1 = 0 Then GoTo 200
        Jx(Nx, Ny, Dx, Dy, Pm1)
        Jy(Nx, Ny, Dx, Dy, Pm1)

        '         pm2*J2 = pm2 * double integral of (fxx)**2+2(fxy)**2+(fyy)**2
200:    If Pm2 = 0 Then GoTo 300
        Jxx(Nx, Ny, Dx, Dy, Pm2)
        Jxy(Nx, Ny, Dx, Dy, Pm2)
        Jyy(Nx, Ny, Dx, Dy, Pm2)

        '        alpha*Rh = alpha * sum of (f(xh(k),yh(k)) - zh(k))**2
300:    Hmat(f, Nx, Ny, Xmin, Ymin, Dx, Dy, Xh, Yh, Zh, Lm, Nh, Nhdt, AlphaH)

        '        beta*Rd = BetaH * sum of (fx(xh(k),yh(k)) - dfdx(k))**2
        '                              + (fy(xh(k),yh(k)) - dfdy(k))**2
        Dmat(Nx, Ny, Xmin, Ymin, Dx, Dy, Xd, Yd, Dfdx, Dfdy, Nd, Nddt, BetaH)

        '      write (*,90) nhdt,nddt
        '   90 format (' number of elevation constrains : nhdt =',i4/
        '     &        ' number of slope constraints    : nddt =',i4)
        If Nhdt < 1 Then Exit Sub
        If (Nhdt + 2 * Nddt) < 3 Then Exit Sub
        IFLG = 0

    End Sub

End Module
